#ifndef __MUTEX_H
#define __MUTEX_H

#define MUTEX_INVALID_THREAD_ID 100
#define MUTEX_OK 0
#define MUTEX_ERROR -1

typedef struct _mutex_t
{
   /* ... */
} mutex_t;

 
/* muss das Mutex Objekt initialisieren, z.B. Speicher anlegen usw., 
 * liefert einen Zeiger auf eine mutex_t Struktur oder NULL im Fehlerfall 
 */
mutex_t* mutex_init();
/* Fordert den Zugriff auf das Mutex-Objekt an. 
 * Blockiert bis der Zugriff erfolgt oder ein Fehler auftrat
 * Liefert MUTEX_OK bei Erfolg und MUTEX_ERROR im Fehlerfall 
 */
int mutex_lock(mutex_t*);
/*  Gibt das Mutex-Objekt wieder frei
 *  Liefert MUTEX_OK bei Erfolg, MUTEX_ERROR im Fehlerfall und
 *  MUTEX_INVALID_THREAD_ID, wenn dieser Thread nicht mit 
 *  mutex_lock das Mutex-Objekt angefordert hatte
 */
int mutex_unlock(mutex_t*);

#endif
